/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_IDENTIFIER = 258,
     T_TYPEDEF_NAME = 259,
     T_DEFINE_NAME = 260,
     T_AUTO = 261,
     T_EXTERN = 262,
     T_REGISTER = 263,
     T_STATIC = 264,
     T_TYPEDEF = 265,
     T_INLINE = 266,
     T_EXTENSION = 267,
     T_CHAR = 268,
     T_DOUBLE = 269,
     T_FLOAT = 270,
     T_INT = 271,
     T_VOID = 272,
     T_LONG = 273,
     T_SHORT = 274,
     T_SIGNED = 275,
     T_UNSIGNED = 276,
     T_ENUM = 277,
     T_STRUCT = 278,
     T_UNION = 279,
     T_Bool = 280,
     T_Complex = 281,
     T_Imaginary = 282,
     T_TYPE_QUALIFIER = 283,
     T_BRACKETS = 284,
     T_LBRACE = 285,
     T_MATCHRBRACE = 286,
     T_ELLIPSIS = 287,
     T_INITIALIZER = 288,
     T_STRING_LITERAL = 289,
     T_ASM = 290,
     T_ASMARG = 291,
     T_VA_DCL = 292
   };
#endif
/* Tokens.  */
#define T_IDENTIFIER 258
#define T_TYPEDEF_NAME 259
#define T_DEFINE_NAME 260
#define T_AUTO 261
#define T_EXTERN 262
#define T_REGISTER 263
#define T_STATIC 264
#define T_TYPEDEF 265
#define T_INLINE 266
#define T_EXTENSION 267
#define T_CHAR 268
#define T_DOUBLE 269
#define T_FLOAT 270
#define T_INT 271
#define T_VOID 272
#define T_LONG 273
#define T_SHORT 274
#define T_SIGNED 275
#define T_UNSIGNED 276
#define T_ENUM 277
#define T_STRUCT 278
#define T_UNION 279
#define T_Bool 280
#define T_Complex 281
#define T_Imaginary 282
#define T_TYPE_QUALIFIER 283
#define T_BRACKETS 284
#define T_LBRACE 285
#define T_MATCHRBRACE 286
#define T_ELLIPSIS 287
#define T_INITIALIZER 288
#define T_STRING_LITERAL 289
#define T_ASM 290
#define T_ASMARG 291
#define T_VA_DCL 292




/* Copy the first part of user declarations.  */
#line 68 "./grammar.y"

#include <stdio.h>
#include <ctype.h>
#include "cproto.h"
#include "symbol.h"
#include "semantic.h"

#define YYMAXDEPTH 150

extern	int	yylex (void);

/* declaration specifier attributes for the typedef statement currently being
 * scanned
 */
static int cur_decl_spec_flags;

/* pointer to parameter list for the current function definition */
static ParameterList *func_params;

/* A parser semantic action sets this pointer to the current declarator in
 * a function parameter declaration in order to catch any comments following
 * the parameter declaration on the same line.  If the lexer scans a comment
 * and <cur_declarator> is not NULL, then the comment is attached to the
 * declarator.  To ignore subsequent comments, the lexer sets this to NULL
 * after scanning a comment or end of line.
 */
static Declarator *cur_declarator;

/* temporary string buffer */
static char *temp_buf = 0;
static unsigned temp_len = 0;

/* table of typedef names */
static SymbolTable *typedef_names;

/* table of define names */
static SymbolTable *define_names;

/* table of type qualifiers */
static SymbolTable *type_qualifiers;

/* information about the current input file */
typedef struct {
    char *base_name;		/* base input file name */
    char *file_name;		/* current file name */
    unsigned len_file_name;	/* ...its allocated size */
    FILE *file; 		/* input file */
    unsigned line_num;		/* current line number in input file */
    FILE *tmp_file;		/* temporary file */
    long begin_comment; 	/* tmp file offset after last written ) or ; */
    long end_comment;		/* tmp file offset after last comment */
    boolean convert;		/* if TRUE, convert function definitions */
    boolean changed;		/* TRUE if conversion done in this file */
} IncludeStack;

static IncludeStack *cur_file;	/* current input file */

#include "yyerror.c"

static int haveAnsiParam (void);


/* Flags to enable us to find if a procedure returns a value.
 */
static int return_val,	/* nonzero on BRACES iff return-expression found */
	   returned_at;	/* marker for token-number to set 'return_val' */

#if OPT_LINTLIBRARY
static char *dft_decl_spec (void);

static char *
dft_decl_spec (void)
{
    return (lintLibrary() && !return_val) ? "void" : "int";
}

#else
#define dft_decl_spec() "int"
#endif

static int
haveAnsiParam (void)
{
    Parameter *p;
    if (func_params != 0) {
	for (p = func_params->first; p != 0; p = p->next) {
	    if (p->declarator->func_def == FUNC_ANSI) {
		return TRUE;
	    }
	}
    }
    return FALSE;
}

static void need_temp(unsigned need)
{
    if (need > temp_len) {
	if (need < MAX_TEXT_SIZE)
	    need = MAX_TEXT_SIZE;
	if (need < temp_len * 2)
	    need = temp_len * 2;
	temp_buf = type_realloc(char, temp_buf, need);
	temp_len = need;
    }
}


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */
#line 277 "y.tab.c"

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  67
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   527

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  45
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  44
/* YYNRULES -- Number of rules. */
#define YYNRULES  117
/* YYNRULES -- Number of states. */
#define YYNSTATES  155

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   292

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     5,     2,
       3,    44,     4,     2,    42,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    41,
       2,    43,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     6,     8,    11,    13,    15,    17,
      19,    21,    24,    27,    30,    34,    38,    41,    45,    46,
      52,    55,    57,    58,    60,    62,    66,    67,    68,    76,
      77,    83,    84,    86,    88,    90,    93,    95,    98,   100,
     102,   104,   106,   108,   110,   112,   114,   116,   118,   120,
     122,   124,   126,   128,   130,   132,   134,   136,   138,   140,
     142,   144,   146,   148,   150,   154,   157,   160,   162,   164,
     166,   170,   172,   173,   178,   181,   185,   189,   192,   195,
     197,   199,   201,   204,   206,   208,   212,   215,   220,   225,
     228,   232,   233,   235,   237,   240,   242,   246,   248,   252,
     255,   258,   260,   261,   263,   265,   269,   271,   274,   276,
     279,   281,   285,   288,   290,   295,   299,   303
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      46,     0,    -1,    -1,    47,    -1,    48,    -1,    47,    48,
      -1,    51,    -1,    56,    -1,    41,    -1,    50,    -1,    72,
      -1,     1,    34,    -1,     1,    41,    -1,    33,    34,    -1,
      10,    37,    49,    -1,    10,    37,    51,    -1,    62,    41,
      -1,    62,    69,    41,    -1,    -1,    53,    62,    52,    54,
      41,    -1,    15,    13,    -1,    13,    -1,    -1,    55,    -1,
      76,    -1,    55,    42,    76,    -1,    -1,    -1,    62,    76,
      57,    60,    33,    58,    34,    -1,    -1,    76,    59,    60,
      33,    34,    -1,    -1,    40,    -1,    61,    -1,    51,    -1,
      61,    51,    -1,    63,    -1,    62,    63,    -1,    64,    -1,
      65,    -1,    66,    -1,     9,    -1,    10,    -1,    11,    -1,
      12,    -1,    14,    -1,    15,    -1,    16,    -1,    17,    -1,
      18,    -1,    19,    -1,    21,    -1,    22,    -1,    23,    -1,
      24,    -1,    20,    -1,    28,    -1,    29,    -1,    30,    -1,
       7,    -1,    67,    -1,    73,    -1,    31,    -1,     8,    -1,
      68,    75,    49,    -1,    68,    49,    -1,    68,    75,    -1,
      26,    -1,    27,    -1,    70,    -1,    69,    42,    70,    -1,
      76,    -1,    -1,    76,    43,    71,    36,    -1,    38,    39,
      -1,    83,    38,    39,    -1,    74,    75,    49,    -1,    74,
      49,    -1,    74,    75,    -1,    25,    -1,     6,    -1,     7,
      -1,    78,    77,    -1,    77,    -1,    86,    -1,     3,    76,
      44,    -1,    77,    32,    -1,    77,     3,    81,    44,    -1,
      77,     3,    84,    44,    -1,     4,    79,    -1,     4,    79,
      78,    -1,    -1,    80,    -1,    66,    -1,    80,    66,    -1,
      82,    -1,    82,    42,    35,    -1,    83,    -1,    82,    42,
      83,    -1,    62,    76,    -1,    62,    87,    -1,    62,    -1,
      -1,    85,    -1,    75,    -1,    85,    42,    75,    -1,    75,
      -1,     5,    75,    -1,    78,    -1,    78,    88,    -1,    88,
      -1,     3,    87,    44,    -1,    88,    32,    -1,    32,    -1,
      88,     3,    81,    44,    -1,    88,     3,    44,    -1,     3,
      81,    44,    -1,     3,    44,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   176,   176,   178,   182,   183,   187,   188,   189,   190,
     191,   192,   196,   203,   207,   214,   221,   232,   247,   246,
     258,   262,   268,   270,   274,   286,   299,   310,   298,   335,
     334,   362,   364,   365,   369,   370,   374,   375,   384,   385,
     386,   390,   394,   398,   402,   406,   410,   417,   421,   425,
     429,   433,   437,   441,   445,   449,   453,   457,   461,   465,
     472,   473,   477,   481,   494,   503,   512,   521,   525,   532,
     536,   543,   553,   552,   564,   565,   572,   581,   590,   599,
     607,   608,   612,   624,   628,   632,   643,   653,   661,   672,
     677,   686,   690,   694,   700,   709,   710,   717,   721,   728,
     733,   738,   747,   750,   754,   759,   766,   770,   783,   787,
     798,   802,   813,   823,   827,   835,   842,   853
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "'('", "'*'", "'&'", "T_IDENTIFIER",
  "T_TYPEDEF_NAME", "T_DEFINE_NAME", "T_AUTO", "T_EXTERN", "T_REGISTER",
  "T_STATIC", "T_TYPEDEF", "T_INLINE", "T_EXTENSION", "T_CHAR", "T_DOUBLE",
  "T_FLOAT", "T_INT", "T_VOID", "T_LONG", "T_SHORT", "T_SIGNED",
  "T_UNSIGNED", "T_ENUM", "T_STRUCT", "T_UNION", "T_Bool", "T_Complex",
  "T_Imaginary", "T_TYPE_QUALIFIER", "T_BRACKETS", "T_LBRACE",
  "T_MATCHRBRACE", "T_ELLIPSIS", "T_INITIALIZER", "T_STRING_LITERAL",
  "T_ASM", "T_ASMARG", "T_VA_DCL", "';'", "','", "'='", "')'", "$accept",
  "program", "translation_unit", "external_declaration", "braces",
  "linkage_specification", "declaration", "@1", "any_typedef",
  "opt_declarator_list", "declarator_list", "function_definition", "@2",
  "@3", "@4", "opt_declaration_list", "declaration_list",
  "decl_specifiers", "decl_specifier", "storage_class", "type_specifier",
  "type_qualifier", "struct_or_union_specifier", "struct_or_union",
  "init_declarator_list", "init_declarator", "@5", "asm_specifier",
  "enum_specifier", "enumeration", "any_id", "declarator",
  "direct_declarator", "pointer", "opt_type_qualifiers",
  "type_qualifier_list", "parameter_type_list", "parameter_list",
  "parameter_declaration", "opt_identifier_list", "identifier_list",
  "identifier_or_ref", "abs_declarator", "direct_abs_declarator", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,    40,    42,    38,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    59,    44,    61,    41
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    45,    46,    46,    47,    47,    48,    48,    48,    48,
      48,    48,    48,    49,    50,    50,    51,    51,    52,    51,
      53,    53,    54,    54,    55,    55,    57,    58,    56,    59,
      56,    60,    60,    60,    61,    61,    62,    62,    63,    63,
      63,    64,    64,    64,    64,    64,    64,    65,    65,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    66,    66,    67,    67,    67,    68,    68,    69,
      69,    70,    71,    70,    72,    72,    73,    73,    73,    74,
      75,    75,    76,    76,    77,    77,    77,    77,    77,    78,
      78,    79,    79,    80,    80,    81,    81,    82,    82,    83,
      83,    83,    84,    84,    85,    85,    86,    86,    87,    87,
      87,    88,    88,    88,    88,    88,    88,    88
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     2,     2,     3,     3,     2,     3,     0,     5,
       2,     1,     0,     1,     1,     3,     0,     0,     7,     0,
       5,     0,     1,     1,     1,     2,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     2,     2,     1,     1,     1,
       3,     1,     0,     4,     2,     3,     3,     2,     2,     1,
       1,     1,     2,     1,     1,     3,     2,     4,     4,     2,
       3,     0,     1,     1,     2,     1,     3,     1,     3,     2,
       2,     1,     0,     1,     1,     3,     1,     2,     1,     2,
       1,     3,     2,     1,     4,     3,     3,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,    91,     0,    80,    59,    63,    41,    42,
      43,    44,    21,    45,    46,    47,    48,    49,    50,    55,
      51,    52,    53,    54,    79,    67,    68,    56,    57,    58,
      62,     0,     8,     0,     0,     4,     9,     6,     0,     7,
     101,    36,    38,    39,    40,    60,     0,    10,    61,     0,
     106,    29,    83,     0,     0,    84,    11,    12,    81,     0,
      93,    89,    92,   107,     0,    20,    74,     1,     5,    59,
      42,    46,    18,     0,   113,    16,    37,     0,    69,    26,
     108,   100,   110,     0,    65,    66,    77,    78,    31,   102,
      86,    82,     0,    85,    90,    94,    14,    15,     0,    22,
     117,   101,     0,    95,    97,     0,    17,     0,    72,    31,
     109,     0,   112,    13,    64,    76,    32,    34,     0,    33,
     104,     0,     0,   103,    75,    71,     0,    23,    24,    99,
     116,     0,   111,    70,     0,     0,   115,     0,     0,    35,
      87,    88,     0,    19,     0,    96,    98,    73,    27,   114,
      30,   105,    25,     0,    28
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,    33,    34,    35,    84,    36,    37,    99,    38,   126,
     127,    39,   109,   153,    88,   118,   119,    98,    41,    42,
      43,    44,    45,    46,    77,    78,   134,    47,    48,    49,
      50,    51,    52,    53,    61,    62,   102,   103,   104,   122,
     123,    55,    81,    82
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -79
static const short int yypact[] =
{
     140,    18,    51,    13,    60,   -79,    -8,   -79,   -79,   -27,
     -79,   -79,   -79,   -79,    -1,   -79,   -79,   -79,   -79,   -79,
     -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,
     -79,   -25,   -79,    22,   179,   -79,   -79,   -79,   496,   -79,
     249,   -79,   -79,   -79,   -79,   -79,    20,   -79,   -79,    20,
     -79,   -79,    16,    76,   -20,   -79,   -79,   -79,   -79,   -16,
     -79,    27,    13,   -79,   418,   -79,   -79,   -79,   -79,   -79,
     -79,   -79,   496,   218,   -79,   -79,   -79,    43,   -79,    35,
      10,   -79,    17,     0,   -79,    29,   -79,    29,   354,   446,
     -79,    16,    21,   -79,   -79,   -79,   -79,   -79,   288,    51,
     -79,   392,    26,    30,   -79,    36,   -79,    51,   -79,   354,
      17,   316,   -79,   -79,   -79,   -79,   -79,   -79,    31,   471,
     -79,    44,    45,    32,   -79,    47,    46,    50,   -79,   -79,
     -79,   100,   -79,   -79,    57,    61,   -79,    54,    66,   -79,
     -79,   -79,    60,   -79,    51,   -79,   -79,   -79,   -79,   -79,
     -79,   -79,   -79,    67,   -79
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -79,   -79,   -79,    68,   -40,   -79,   -58,   -79,   -79,   -79,
     -79,   -79,   -79,   -79,   -79,   -14,   -79,     2,   -33,   -79,
     -79,     1,   -79,   -79,   -79,    -4,   -79,   -79,   -79,   -79,
      -3,    -2,   -30,   -32,   -79,   -79,   -78,   -79,     3,   -79,
     -79,   -79,    33,    24
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -100
static const short int yytable[] =
{
      59,    63,    40,    54,    60,   -81,    97,    76,    80,    86,
      64,   121,    65,    73,    66,     4,     5,    58,    92,    89,
     111,     7,    67,    91,    96,   -81,     5,    58,    93,    94,
     117,     3,   -81,   137,   113,   -81,    40,    54,    79,    76,
      72,    80,    74,    85,    30,   114,    87,   115,    90,   112,
      91,   117,    56,    83,     2,     3,     4,     5,    58,    57,
     124,   139,    83,    95,   138,    76,     5,    58,    76,    80,
     130,    59,   131,   -99,   142,   101,   -71,   -71,   108,     2,
     132,     4,     5,    58,   106,   107,   120,   143,   140,   141,
     108,   101,   144,   147,   148,   135,   125,   128,   149,   129,
     150,   154,    68,   133,   110,   125,   105,    69,     7,     8,
      70,    10,    11,   101,    13,    71,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,     0,   101,   146,   145,     0,     0,     0,   151,
      -2,     1,   152,     2,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,     0,     0,     0,     0,     0,     0,    31,    -3,
       1,    32,     2,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,     0,     0,     0,     0,     0,     0,    31,     0,     0,
      32,    73,     3,     4,     5,     6,     7,     8,    70,    10,
      11,     0,    13,    71,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      74,     0,    73,     3,     4,     5,     6,     7,     8,    70,
      10,    11,   100,    13,    71,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    74,     0,     0,     0,     0,     0,     0,     0,     0,
      75,     2,     3,     4,     5,     6,     7,     8,    70,    10,
      11,     0,    13,    71,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
       0,     0,     0,    69,     7,     8,    70,    10,    11,    75,
      13,    71,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     136,    69,     7,     8,    70,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,     0,     0,     0,     0,
       0,     0,     0,     0,   116,    73,     3,     4,     5,     6,
       7,     8,    70,    10,    11,     0,    13,    71,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    74,    69,     7,     8,    70,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
       0,    83,     5,     6,     7,     8,    70,    10,    11,     0,
      13,    71,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    69,     7,
       8,    70,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    69,     7,     8,    70,    10,    11,     0,
      13,    71,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30
};

static const short int yycheck[] =
{
       2,     4,     0,     0,     3,    13,    64,    40,    40,    49,
      37,    89,    13,     3,    39,     5,     6,     7,    38,     3,
       3,     8,     0,    53,    64,    33,     6,     7,    44,    61,
      88,     4,    40,   111,    34,    43,    34,    34,    40,    72,
      38,    73,    32,    46,    31,    85,    49,    87,    32,    32,
      80,   109,    34,    33,     3,     4,     5,     6,     7,    41,
      39,   119,    33,    62,    33,    98,     6,     7,   101,   101,
      44,    73,    42,    38,    42,    73,    41,    42,    43,     3,
      44,     5,     6,     7,    41,    42,    89,    41,    44,    44,
      43,    89,    42,    36,    33,   109,    98,    99,    44,   101,
      34,    34,    34,   107,    80,   107,    73,     7,     8,     9,
      10,    11,    12,   111,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,   131,   131,    35,    -1,    -1,    -1,   142,
       0,     1,   144,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    38,     0,
       1,    41,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,    -1,
      41,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    44,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      41,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    -1,     7,     8,     9,    10,    11,    12,    41,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    33,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    38,    41,    46,    47,    48,    50,    51,    53,    56,
      62,    63,    64,    65,    66,    67,    68,    72,    73,    74,
      75,    76,    77,    78,    83,    86,    34,    41,     7,    76,
      66,    79,    80,    75,    37,    13,    39,     0,    48,     7,
      10,    15,    62,     3,    32,    41,    63,    69,    70,    76,
      78,    87,    88,    33,    49,    75,    49,    75,    59,     3,
      32,    77,    38,    44,    78,    66,    49,    51,    62,    52,
      44,    62,    81,    82,    83,    87,    41,    42,    43,    57,
      88,     3,    32,    34,    49,    49,    40,    51,    60,    61,
      75,    81,    84,    85,    39,    76,    54,    55,    76,    76,
      44,    42,    44,    70,    71,    60,    44,    81,    33,    51,
      44,    44,    42,    41,    42,    35,    83,    36,    33,    44,
      34,    75,    76,    58,    34
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()
    ;
#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 11:
#line 193 "./grammar.y"
    {
	    yyerrok;
	}
    break;

  case 12:
#line 197 "./grammar.y"
    {
	    yyerrok;
	}
    break;

  case 14:
#line 208 "./grammar.y"
    {
	    /* Provide an empty action here so bison will not complain about
	     * incompatible types in the default action it normally would
	     * have generated.
	     */
	}
    break;

  case 15:
#line 215 "./grammar.y"
    {
	    /* empty */
	}
    break;

  case 16:
#line 222 "./grammar.y"
    {
#if OPT_LINTLIBRARY
	    if (types_out && want_typedef()) {
		gen_declarations(&(yyvsp[-1].decl_spec), (DeclaratorList *)0);
		flush_varargs();
	    }
#endif
	    free_decl_spec(&(yyvsp[-1].decl_spec));
	    end_typedef();
	}
    break;

  case 17:
#line 233 "./grammar.y"
    {
	    if (func_params != NULL) {
		set_param_types(func_params, &(yyvsp[-2].decl_spec), &(yyvsp[-1].decl_list));
	    } else {
		gen_declarations(&(yyvsp[-2].decl_spec), &(yyvsp[-1].decl_list));
#if OPT_LINTLIBRARY
		flush_varargs();
#endif
		free_decl_list(&(yyvsp[-1].decl_list));
	    }
	    free_decl_spec(&(yyvsp[-2].decl_spec));
	    end_typedef();
	}
    break;

  case 18:
#line 247 "./grammar.y"
    {
	    cur_decl_spec_flags = (yyvsp[0].decl_spec).flags;
	    free_decl_spec(&(yyvsp[0].decl_spec));
	}
    break;

  case 19:
#line 252 "./grammar.y"
    {
	    end_typedef();
	}
    break;

  case 20:
#line 259 "./grammar.y"
    {
	    begin_typedef();
	}
    break;

  case 21:
#line 263 "./grammar.y"
    {
	    begin_typedef();
	}
    break;

  case 24:
#line 275 "./grammar.y"
    {
	    int flags = cur_decl_spec_flags;

	    /* If the typedef is a pointer type, then reset the short type
	     * flags so it does not get promoted.
	     */
	    if (strcmp((yyvsp[0].declarator)->text, (yyvsp[0].declarator)->name) != 0)
		flags &= ~(DS_CHAR | DS_SHORT | DS_FLOAT);
	    new_symbol(typedef_names, (yyvsp[0].declarator)->name, NULL, flags);
	    free_declarator((yyvsp[0].declarator));
	}
    break;

  case 25:
#line 287 "./grammar.y"
    {
	    int flags = cur_decl_spec_flags;

	    if (strcmp((yyvsp[0].declarator)->text, (yyvsp[0].declarator)->name) != 0)
		flags &= ~(DS_CHAR | DS_SHORT | DS_FLOAT);
	    new_symbol(typedef_names, (yyvsp[0].declarator)->name, NULL, flags);
	    free_declarator((yyvsp[0].declarator));
	}
    break;

  case 26:
#line 299 "./grammar.y"
    {
	    check_untagged(&(yyvsp[-1].decl_spec));
	    if ((yyvsp[0].declarator)->func_def == FUNC_NONE) {
		yyerror("syntax error");
		YYERROR;
	    }
	    func_params = &((yyvsp[0].declarator)->head->params);
	    func_params->begin_comment = cur_file->begin_comment;
	    func_params->end_comment = cur_file->end_comment;
	}
    break;

  case 27:
#line 310 "./grammar.y"
    {
	    /* If we're converting to K&R and we've got a nominally K&R
	     * function which has a parameter which is ANSI (i.e., a prototyped
	     * function pointer), then we must override the deciphered value of
	     * 'func_def' so that the parameter will be converted.
	     */
	    if (func_style == FUNC_TRADITIONAL
	     && haveAnsiParam()
	     && (yyvsp[-3].declarator)->head->func_def == func_style) {
		(yyvsp[-3].declarator)->head->func_def = FUNC_BOTH;
	    }

	    func_params = NULL;

	    if (cur_file->convert)
		gen_func_definition(&(yyvsp[-4].decl_spec), (yyvsp[-3].declarator));
	    gen_prototype(&(yyvsp[-4].decl_spec), (yyvsp[-3].declarator));
#if OPT_LINTLIBRARY
	    flush_varargs();
#endif
	    free_decl_spec(&(yyvsp[-4].decl_spec));
	    free_declarator((yyvsp[-3].declarator));
	}
    break;

  case 29:
#line 335 "./grammar.y"
    {
	    if ((yyvsp[0].declarator)->func_def == FUNC_NONE) {
		yyerror("syntax error");
		YYERROR;
	    }
	    func_params = &((yyvsp[0].declarator)->head->params);
	    func_params->begin_comment = cur_file->begin_comment;
	    func_params->end_comment = cur_file->end_comment;
	}
    break;

  case 30:
#line 345 "./grammar.y"
    {
	    DeclSpec decl_spec;

	    func_params = NULL;

	    new_decl_spec(&decl_spec, dft_decl_spec(), (yyvsp[-4].declarator)->begin, DS_NONE);
	    if (cur_file->convert)
		gen_func_definition(&decl_spec, (yyvsp[-4].declarator));
	    gen_prototype(&decl_spec, (yyvsp[-4].declarator));
#if OPT_LINTLIBRARY
	    flush_varargs();
#endif
	    free_decl_spec(&decl_spec);
	    free_declarator((yyvsp[-4].declarator));
	}
    break;

  case 37:
#line 376 "./grammar.y"
    {
	    join_decl_specs(&(yyval.decl_spec), &(yyvsp[-1].decl_spec), &(yyvsp[0].decl_spec));
	    free_decl_spec(&(yyvsp[-1].decl_spec));
	    free_decl_spec(&(yyvsp[0].decl_spec));
	}
    break;

  case 41:
#line 391 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
    break;

  case 42:
#line 395 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_EXTERN);
	}
    break;

  case 43:
#line 399 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
    break;

  case 44:
#line 403 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_STATIC);
	}
    break;

  case 45:
#line 407 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_INLINE);
	}
    break;

  case 46:
#line 411 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_JUNK);
	}
    break;

  case 47:
#line 418 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_CHAR);
	}
    break;

  case 48:
#line 422 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
    break;

  case 49:
#line 426 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_FLOAT);
	}
    break;

  case 50:
#line 430 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
    break;

  case 51:
#line 434 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
    break;

  case 52:
#line 438 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_SHORT);
	}
    break;

  case 53:
#line 442 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
    break;

  case 54:
#line 446 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
    break;

  case 55:
#line 450 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
    break;

  case 56:
#line 454 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_CHAR);
	}
    break;

  case 57:
#line 458 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
    break;

  case 58:
#line 462 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
    break;

  case 59:
#line 466 "./grammar.y"
    {
	    Symbol *s;
	    s = find_symbol(typedef_names, (yyvsp[0].text).text);
	    if (s != NULL)
		new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, s->flags);
	}
    break;

  case 62:
#line 478 "./grammar.y"
    {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
    break;

  case 63:
#line 482 "./grammar.y"
    {
	    /* This rule allows the <pointer> nonterminal to scan #define
	     * names as if they were type modifiers.
	     */
	    Symbol *s;
	    s = find_symbol(define_names, (yyvsp[0].text).text);
	    if (s != NULL)
		new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, s->flags);
	}
    break;

  case 64:
#line 495 "./grammar.y"
    {
	    char *s;
	    if ((s = implied_typedef()) == 0) {
		need_temp(2 + 2 * strlen((yyvsp[-2].text).text));
	        (void)sprintf(s = temp_buf, "%s %s", (yyvsp[-2].text).text, (yyvsp[-1].text).text);
	    }
	    new_decl_spec(&(yyval.decl_spec), s, (yyvsp[-2].text).begin, DS_NONE);
	}
    break;

  case 65:
#line 504 "./grammar.y"
    {
	    char *s;
	    if ((s = implied_typedef()) == 0) {
		need_temp(4 + strlen((yyvsp[-1].text).text));
		(void)sprintf(s = temp_buf, "%s {}", (yyvsp[-1].text).text);
	    }
	    new_decl_spec(&(yyval.decl_spec), s, (yyvsp[-1].text).begin, DS_NONE);
	}
    break;

  case 66:
#line 513 "./grammar.y"
    {
	    need_temp(2 + 2 * strlen((yyvsp[-1].text).text));
	    (void)sprintf(temp_buf, "%s %s", (yyvsp[-1].text).text, (yyvsp[0].text).text);
	    new_decl_spec(&(yyval.decl_spec), temp_buf, (yyvsp[-1].text).begin, DS_NONE);
	}
    break;

  case 67:
#line 522 "./grammar.y"
    {
	    imply_typedef((yyval.text).text);
	}
    break;

  case 68:
#line 526 "./grammar.y"
    {
	    imply_typedef((yyval.text).text);
	}
    break;

  case 69:
#line 533 "./grammar.y"
    {
	    new_decl_list(&(yyval.decl_list), (yyvsp[0].declarator));
	}
    break;

  case 70:
#line 537 "./grammar.y"
    {
	    add_decl_list(&(yyval.decl_list), &(yyvsp[-2].decl_list), (yyvsp[0].declarator));
	}
    break;

  case 71:
#line 544 "./grammar.y"
    {
	    if ((yyvsp[0].declarator)->func_def != FUNC_NONE && func_params == NULL &&
		func_style == FUNC_TRADITIONAL && cur_file->convert) {
		gen_func_declarator((yyvsp[0].declarator));
		fputs(cur_text(), cur_file->tmp_file);
	    }
	    cur_declarator = (yyval.declarator);
	}
    break;

  case 72:
#line 553 "./grammar.y"
    {
	    if ((yyvsp[-1].declarator)->func_def != FUNC_NONE && func_params == NULL &&
		func_style == FUNC_TRADITIONAL && cur_file->convert) {
		gen_func_declarator((yyvsp[-1].declarator));
		fputs(" =", cur_file->tmp_file);
	    }
	}
    break;

  case 75:
#line 566 "./grammar.y"
    {
	    free_parameter((yyvsp[-2].parameter));
	}
    break;

  case 76:
#line 573 "./grammar.y"
    {
	    char *s;
	    if ((s = implied_typedef()) == 0) {
		need_temp(6 + strlen((yyvsp[-1].text).text));
		(void)sprintf(s = temp_buf, "enum %s", (yyvsp[-1].text).text);
	    }
	    new_decl_spec(&(yyval.decl_spec), s, (yyvsp[-2].text).begin, DS_NONE);
	}
    break;

  case 77:
#line 582 "./grammar.y"
    {
	    char *s;
	    if ((s = implied_typedef()) == 0) {
		need_temp(4 + strlen((yyvsp[-1].text).text));
		(void)sprintf(s = temp_buf, "%s {}", (yyvsp[-1].text).text);
	    }
	    new_decl_spec(&(yyval.decl_spec), s, (yyvsp[-1].text).begin, DS_NONE);
	}
    break;

  case 78:
#line 591 "./grammar.y"
    {
	    need_temp(6 + strlen((yyvsp[0].text).text));
	    (void)sprintf(temp_buf, "enum %s", (yyvsp[0].text).text);
	    new_decl_spec(&(yyval.decl_spec), temp_buf, (yyvsp[-1].text).begin, DS_NONE);
	}
    break;

  case 79:
#line 600 "./grammar.y"
    {
	    imply_typedef("enum");
	    (yyval.text) = (yyvsp[0].text);
	}
    break;

  case 82:
#line 613 "./grammar.y"
    {
	    (yyval.declarator) = (yyvsp[0].declarator);

	    need_temp(1 + strlen((yyvsp[-1].text).text) + strlen((yyvsp[0].declarator)->text));
	    (void)sprintf(temp_buf, "%s%s", (yyvsp[-1].text).text, (yyval.declarator)->text);

	    free((yyval.declarator)->text);
	    (yyval.declarator)->text = xstrdup(temp_buf);
	    (yyval.declarator)->begin = (yyvsp[-1].text).begin;
	    (yyval.declarator)->pointer = TRUE;
	}
    break;

  case 84:
#line 629 "./grammar.y"
    {
	    (yyval.declarator) = new_declarator((yyvsp[0].text).text, (yyvsp[0].text).text, (yyvsp[0].text).begin);
	}
    break;

  case 85:
#line 633 "./grammar.y"
    {
	    (yyval.declarator) = (yyvsp[-1].declarator);

	    need_temp(2 + strlen((yyvsp[-1].declarator)->text));
	    (void)sprintf(temp_buf, "(%s)", (yyval.declarator)->text);

	    free((yyval.declarator)->text);
	    (yyval.declarator)->text = xstrdup(temp_buf);
	    (yyval.declarator)->begin = (yyvsp[-2].text).begin;
	}
    break;

  case 86:
#line 644 "./grammar.y"
    {
	    (yyval.declarator) = (yyvsp[-1].declarator);

	    need_temp(1 + strlen((yyvsp[-1].declarator)->text) + strlen((yyvsp[0].text).text));
	    (void)sprintf(temp_buf, "%s%s", (yyval.declarator)->text, (yyvsp[0].text).text);

	    free((yyval.declarator)->text);
	    (yyval.declarator)->text = xstrdup(temp_buf);
	}
    break;

  case 87:
#line 654 "./grammar.y"
    {
	    (yyval.declarator) = new_declarator("%s()", (yyvsp[-3].declarator)->name, (yyvsp[-3].declarator)->begin);
	    (yyval.declarator)->params = (yyvsp[-1].param_list);
	    (yyval.declarator)->func_stack = (yyvsp[-3].declarator);
	    (yyval.declarator)->head = ((yyvsp[-3].declarator)->func_stack == NULL) ? (yyval.declarator) : (yyvsp[-3].declarator)->head;
	    (yyval.declarator)->func_def = FUNC_ANSI;
	}
    break;

  case 88:
#line 662 "./grammar.y"
    {
	    (yyval.declarator) = new_declarator("%s()", (yyvsp[-3].declarator)->name, (yyvsp[-3].declarator)->begin);
	    (yyval.declarator)->params = (yyvsp[-1].param_list);
	    (yyval.declarator)->func_stack = (yyvsp[-3].declarator);
	    (yyval.declarator)->head = ((yyvsp[-3].declarator)->func_stack == NULL) ? (yyval.declarator) : (yyvsp[-3].declarator)->head;
	    (yyval.declarator)->func_def = FUNC_TRADITIONAL;
	}
    break;

  case 89:
#line 673 "./grammar.y"
    {
	    (void)sprintf((yyval.text).text, "*%s", (yyvsp[0].text).text);
	    (yyval.text).begin = (yyvsp[-1].text).begin;
	}
    break;

  case 90:
#line 678 "./grammar.y"
    {
	    (void)sprintf((yyval.text).text, "*%s%s", (yyvsp[-1].text).text, (yyvsp[0].text).text);
	    (yyval.text).begin = (yyvsp[-2].text).begin;
	}
    break;

  case 91:
#line 686 "./grammar.y"
    {
	    strcpy((yyval.text).text, "");
	    (yyval.text).begin = 0L;
	}
    break;

  case 93:
#line 695 "./grammar.y"
    {
	    (void)sprintf((yyval.text).text, "%s ", (yyvsp[0].decl_spec).text);
	    (yyval.text).begin = (yyvsp[0].decl_spec).begin;
	    free((yyvsp[0].decl_spec).text);
	}
    break;

  case 94:
#line 701 "./grammar.y"
    {
	    (void)sprintf((yyval.text).text, "%s%s ", (yyvsp[-1].text).text, (yyvsp[0].decl_spec).text);
	    (yyval.text).begin = (yyvsp[-1].text).begin;
	    free((yyvsp[0].decl_spec).text);
	}
    break;

  case 96:
#line 711 "./grammar.y"
    {
	    add_ident_list(&(yyval.param_list), &(yyvsp[-2].param_list), "...");
	}
    break;

  case 97:
#line 718 "./grammar.y"
    {
	    new_param_list(&(yyval.param_list), (yyvsp[0].parameter));
	}
    break;

  case 98:
#line 722 "./grammar.y"
    {
	    add_param_list(&(yyval.param_list), &(yyvsp[-2].param_list), (yyvsp[0].parameter));
	}
    break;

  case 99:
#line 729 "./grammar.y"
    {
	    check_untagged(&(yyvsp[-1].decl_spec));
	    (yyval.parameter) = new_parameter(&(yyvsp[-1].decl_spec), (yyvsp[0].declarator));
	}
    break;

  case 100:
#line 734 "./grammar.y"
    {
	    check_untagged(&(yyvsp[-1].decl_spec));
	    (yyval.parameter) = new_parameter(&(yyvsp[-1].decl_spec), (yyvsp[0].declarator));
	}
    break;

  case 101:
#line 739 "./grammar.y"
    {
	    check_untagged(&(yyvsp[0].decl_spec));
	    (yyval.parameter) = new_parameter(&(yyvsp[0].decl_spec), (Declarator *)0);
	}
    break;

  case 102:
#line 747 "./grammar.y"
    {
	    new_ident_list(&(yyval.param_list));
	}
    break;

  case 104:
#line 755 "./grammar.y"
    {
	    new_ident_list(&(yyval.param_list));
	    add_ident_list(&(yyval.param_list), &(yyval.param_list), (yyvsp[0].text).text);
	}
    break;

  case 105:
#line 760 "./grammar.y"
    {
	    add_ident_list(&(yyval.param_list), &(yyvsp[-2].param_list), (yyvsp[0].text).text);
	}
    break;

  case 106:
#line 767 "./grammar.y"
    {
	    (yyval.text) = (yyvsp[0].text);
	}
    break;

  case 107:
#line 771 "./grammar.y"
    {
#if OPT_LINTLIBRARY
	    if (lintLibrary()) { /* Lint doesn't grok C++ ref variables */
		(yyval.text) = (yyvsp[0].text);
	    } else
#endif
		(void)sprintf((yyval.text).text, "&%s", (yyvsp[0].text).text);
	    (yyval.text).begin = (yyvsp[-1].text).begin;
	}
    break;

  case 108:
#line 784 "./grammar.y"
    {
	    (yyval.declarator) = new_declarator((yyvsp[0].text).text, "", (yyvsp[0].text).begin);
	}
    break;

  case 109:
#line 788 "./grammar.y"
    {
	    (yyval.declarator) = (yyvsp[0].declarator);

	    need_temp(1 + strlen((yyvsp[-1].text).text) + strlen((yyvsp[0].declarator)->text));
	    (void)sprintf(temp_buf, "%s%s", (yyvsp[-1].text).text, (yyval.declarator)->text);

	    free((yyval.declarator)->text);
	    (yyval.declarator)->text = xstrdup(temp_buf);
	    (yyval.declarator)->begin = (yyvsp[-1].text).begin;
	}
    break;

  case 111:
#line 803 "./grammar.y"
    {
	    (yyval.declarator) = (yyvsp[-1].declarator);

	    need_temp(3 + strlen((yyvsp[-1].declarator)->text));
	    (void)sprintf(temp_buf, "(%s)", (yyval.declarator)->text);

	    free((yyval.declarator)->text);
	    (yyval.declarator)->text = xstrdup(temp_buf);
	    (yyval.declarator)->begin = (yyvsp[-2].text).begin;
	}
    break;

  case 112:
#line 814 "./grammar.y"
    {
	    (yyval.declarator) = (yyvsp[-1].declarator);

	    need_temp(1 + strlen((yyvsp[-1].declarator)->text) + strlen((yyvsp[0].text).text));
	    (void)sprintf(temp_buf, "%s%s", (yyval.declarator)->text, (yyvsp[0].text).text);

	    free((yyval.declarator)->text);
	    (yyval.declarator)->text = xstrdup(temp_buf);
	}
    break;

  case 113:
#line 824 "./grammar.y"
    {
	    (yyval.declarator) = new_declarator((yyvsp[0].text).text, "", (yyvsp[0].text).begin);
	}
    break;

  case 114:
#line 828 "./grammar.y"
    {
	    (yyval.declarator) = new_declarator("%s()", "", (yyvsp[-3].declarator)->begin);
	    (yyval.declarator)->params = (yyvsp[-1].param_list);
	    (yyval.declarator)->func_stack = (yyvsp[-3].declarator);
	    (yyval.declarator)->head = ((yyvsp[-3].declarator)->func_stack == NULL) ? (yyval.declarator) : (yyvsp[-3].declarator)->head;
	    (yyval.declarator)->func_def = FUNC_ANSI;
	}
    break;

  case 115:
#line 836 "./grammar.y"
    {
	    (yyval.declarator) = new_declarator("%s()", "", (yyvsp[-2].declarator)->begin);
	    (yyval.declarator)->func_stack = (yyvsp[-2].declarator);
	    (yyval.declarator)->head = ((yyvsp[-2].declarator)->func_stack == NULL) ? (yyval.declarator) : (yyvsp[-2].declarator)->head;
	    (yyval.declarator)->func_def = FUNC_ANSI;
	}
    break;

  case 116:
#line 843 "./grammar.y"
    {
	    Declarator *d;

	    d = new_declarator("", "", (yyvsp[-2].text).begin);
	    (yyval.declarator) = new_declarator("%s()", "", (yyvsp[-2].text).begin);
	    (yyval.declarator)->params = (yyvsp[-1].param_list);
	    (yyval.declarator)->func_stack = d;
	    (yyval.declarator)->head = (yyval.declarator);
	    (yyval.declarator)->func_def = FUNC_ANSI;
	}
    break;

  case 117:
#line 854 "./grammar.y"
    {
	    Declarator *d;

	    d = new_declarator("", "", (yyvsp[-1].text).begin);
	    (yyval.declarator) = new_declarator("%s()", "", (yyvsp[-1].text).begin);
	    (yyval.declarator)->func_stack = d;
	    (yyval.declarator)->head = (yyval.declarator);
	    (yyval.declarator)->func_def = FUNC_ANSI;
	}
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */
#line 2298 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (YY_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 865 "./grammar.y"


#if defined(HAVE_CONFIG_H)
# include "lex.yy.c"
#else
#if defined(__EMX__) || defined(MSDOS) || defined(OS2) || defined(WIN32) || defined(vms)
# ifdef USE_flex
#  include "lexyy.c"
# else
#  include "lex_yy.c"
# endif
#else
# include "lex.yy.c"
#endif
#endif

static void
yaccError (char *msg)
{
    func_params = NULL;
    put_error();		/* tell what line we're on, and what file */
    fprintf(stderr, "%s at token '%s'\n", msg, yytext);
}

/* Initialize the table of type qualifier keywords recognized by the lexical
 * analyzer.
 */
void
init_parser (void)
{
    static char *keywords[] = {
	"const",
	"restrict",
	"volatile",
	"interrupt",
#ifdef vms
	"noshare",
	"readonly",
#endif
#if defined(MSDOS) || defined(OS2)
	"__cdecl",
	"__export",
	"__far",
	"__fastcall",
	"__fortran",
	"__huge",
	"__inline",
	"__interrupt",
	"__loadds",
	"__near",
	"__pascal",
	"__saveregs",
	"__segment",
	"__stdcall",
	"__syscall",
	"_cdecl",
	"_cs",
	"_ds",
	"_es",
	"_export",
	"_far",
	"_fastcall",
	"_fortran",
	"_huge",
	"_interrupt",
	"_loadds",
	"_near",
	"_pascal",
	"_saveregs",
	"_seg",
	"_segment",
	"_ss",
	"cdecl",
	"far",
	"huge",
	"near",
	"pascal",
#ifdef OS2
	"__far16",
#endif
#endif
#ifdef __GNUC__
	/* gcc aliases */
	"__builtin_va_arg",
	"__builtin_va_list",
	"__const",
	"__const__",
	"__inline",
	"__inline__",
	"__restrict",
	"__restrict__",
	"__volatile",
	"__volatile__",
#endif
    };
    unsigned i;

    /* Initialize type qualifier table. */
    type_qualifiers = new_symbol_table();
    for (i = 0; i < sizeof(keywords)/sizeof(keywords[0]); ++i) {
	new_symbol(type_qualifiers, keywords[i], NULL, DS_NONE);
    }
}

/* Process the C source file.  Write function prototypes to the standard
 * output.  Convert function definitions and write the converted source
 * code to a temporary file.
 */
void
process_file (FILE *infile, char *name)
{
    char *s;

    if (strlen(name) > 2) {
	s = name + strlen(name) - 2;
	if (*s == '.') {
	    ++s;
	    if (*s == 'l' || *s == 'y')
		BEGIN LEXYACC;
#if defined(MSDOS) || defined(OS2)
	    if (*s == 'L' || *s == 'Y')
		BEGIN LEXYACC;
#endif
	}
    }

    included_files = new_symbol_table();
    typedef_names = new_symbol_table();
    define_names = new_symbol_table();
    inc_depth = -1;
    curly = 0;
    ly_count = 0;
    func_params = NULL;
    yyin = infile;
    include_file(strcpy(base_file, name), func_style != FUNC_NONE);
    if (file_comments) {
#if OPT_LINTLIBRARY
    	if (lintLibrary()) {
	    put_blankline(stdout);
	    begin_tracking();
	}
#endif
	put_string(stdout, "/* ");
	put_string(stdout, cur_file_name());
	put_string(stdout, " */\n");
    }
    yyparse();
    free_symbol_table(define_names);
    free_symbol_table(typedef_names);
    free_symbol_table(included_files);
}

#ifdef NO_LEAKS
void
free_parser(void)
{
    free_symbol_table (type_qualifiers);
#ifdef FLEX_SCANNER
    if (yy_current_buffer != 0)
	yy_delete_buffer(yy_current_buffer);
#endif
    if (temp_buf != 0) {
	temp_buf = 0;
	temp_len = 0;
    }
}
#endif


